$VDT::GraceTick = 3;

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
	{
		exec("Add-Ons/System_ReturnToBlockland/hooks/ServerControl.cs");
	}
	RTB_registerPref("Timer", "Vehicle Timer Kill", "$VDT::Time", "int 5 50", "Server_VTD", 20, 0, 0);
} else {
	$VDT::Time = 20;
}

RegisterOutputEvent(Player,DisableDismountKill,bool,0);


function Player::DisableDismountKill(%this,%toggle)
{
	if(isObject(%this.client))
	{
		if(isObject(%this.client.player))
		{
			%this.VDTDismountKill = %toggle;
		}
	}
}

package VehicleDeathTimer
{
	function Vehicle::onDriverLeave(%Obj,%Player)
	{
		%Client = %Player.Client;
		%Parent = Parent::onDriverLeave(%Obj,%Player);
		
		if(!$VDT::Time)
		return %Parent;

		if(!%Client.Minigame)
		return %Parent;

		if(%Obj.DataBlock.GetName() $= "SkiVehicle")
		return %Parent;

		if(%Player.VDTDismountKill)
		return %Parent;

		Parent::onDriverLeave(%Obj,%Player);
		%Player.VDTSafe = 0;
		%Player.VDTBeginSched = Schedule($VDT::GraceTick @ "000",0,VehicleDeathTimer,%Client,%Player,$VDT::Time,$VDT::Time,0);
	}

	function WheeledVehicleData::onCollision(%this, %obj, %col, %vec, %vecLen)
	{
		parent::onCollision(%this, %obj, %col, %vec, %vecLen);
		Schedule(50,0,isMountedToVehicle,%Col.Client);
	}

	function VehicleDeathTimer(%Client,%Player,%Tick,%FixedTick,%Col)
	{
		if(!isObject(%Player))
		return;
		if(%Player.VDTSafe)
		return;
		if(%Player.VDTDismountKill)
		return;

		cancel(%Player.VDTSched);
		cancel(%Player.VDTBeginSched);

		if(%Tick >= 20) %Col = "ffff00";
		if(%Tick == 19) %Col = "ffee00";
		if(%Tick == 18) %Col = "ffdd00";
		if(%Tick == 17) %Col = "ffcc00";
		if(%Tick == 16) %Col = "ffbb00";
		if(%Tick == 15) %Col = "ffaa00";
		if(%Tick == 14) %Col = "ff9900";
		if(%Tick == 13) %Col = "ff8800";
		if(%Tick == 12) %Col = "ff7700";
		if(%Tick == 11) %Col = "ff6600";
		if(%Tick == 10) %Col = "ff5500";
		if(%Tick == 9)  %Col = "ff4400";
		if(%Tick == 8)  %Col = "ff3300";
		if(%Tick == 7)  %Col = "ff2200";
		if(%Tick == 6)  %Col = "ff1100";
		if(%Tick <= 5)  %Col = "ff0000";
		
		if(%FixedTick != $VDT::Time)
		{
			%FixedTick = $VDT::Time;
			%Tick = $VDT::Time;
		}
		BottomPrint(%Client,"<br><br><br><font:impact:30><color:" @ %col @ ">You will be killed in \c6" @ %tick @ "<color:" @ %col @ "> seconds if you don't return to a vehicle",2);

		if(%Tick < 1)
		{
			BottomPrint(%Client,"",0);
			VDTKill(%Client,0);
			return;
		}

		%Tick--;
		%Player.VDTSched = Schedule(1000,0,VehicleDeathTimer,%Client,%Player,%Tick,%FixedTick,%Col);
	}
	function VDTKill(%Client,%Col)
	{
		%Player = %Client.Player;
		if(!isObject(%Player))
		return;
		if(%Player.VDTSafe)
		return;
		if(%Player.VDTDismountKill)
		return;
		
		cancel(%Player.VDTSched);
		%Player.addHealth(-20);
		%Player.setDamageFlash(1);
		
		if(%Col)
		%Col = 0;
		else
		%Col = 1;

		if(%Col)
		CenterPrint(%Client,"<br><br><br><font:impact:60><color:ff0000>Return to a vehicle!",2);
		else
		CenterPrint(%Client,"<br><br><br><font:impact:60><color:ffffff>Return to a vehicle!",2);

		%Player.VDTSched = schedule(1000,0,VDTKill,%Client,%Col);
		
	}
	function isMountedToVehicle(%Client)
	{
		%Player = %Client.Player;
		if(!isObject(%Player))
		return;
		
		if(isObject(%Player.GetObjectMount()))
		{
			BottomPrint(%Client,"",0);
			%Player.VDTSafe = 1;
			cancel(%Player.VDTSched);
			cancel(%Player.VDTBeginSched);
		}
	}


	function ServerCmdLeaveMinigame(%client)
	{
		parent::ServerCmdLeaveMinigame(%client);

		%Player = %Client.Player;
		%Player.VDTSafe = 1;
		cancel(%Player.VDTSched);
		cancel(%Player.VDTBeginSched);
	}
	function MinigameSO::endGame(%this)
    	{
		for(%i = 0; %i < ClientGroup.getcount();%i++)
		{
			%a = ClientGroup.getobject(%i);
			%a.player.VDTSafe = 1;
			cancel(%a.Player.VDTSched);
			cancel(%a.Player.VDTBeginSched);
		}
		parent::endGame(%this);
	}
	function GameConnection::spawnPlayer(%this)
	{
		parent::spawnPlayer(%this);

		%This.Player.VDTSafe = 1;
		cancel(%This.Player.VDTSched);
		cancel(%This.Player.VDTBeginSched);
	}

};
ActivatePackage(VehicleDeathTimer);